{⨭ 6

ꥪ Font1}

UNIT LIST06;

        INTERFACE

                USES GRAPH, LIST05;

                TYPE

                {$IFOPT N+}
                        FLOAT = DOUBLE;
                {$ELSE}
                        FLOAT = REAL;
                {$ENDIF}

                FONT1 = OBJECT(BgiFont)                                { ᪠  ⠡    }
                        MX:FLOAT;                                { ⠡  X }
                        MY:FLOAT;                                { ⠡  Y }
                        AlFA:FLOAT;                                {   ப  ࠤ}
                        X0,Y0:FLOAT;                                { न 業 饭 }
                        SN,CN:FLOAT;                                {   ᨭ 㣫  }

                        PROCEDURE SetParameters1(MXX,MYY,A:FLOAT;
                                X00,Y00:INTEGER); VIRTUAL;        { 樠 ࠬ஢  ८ࠧ }
                        FUNCTION SymbolHeight:INTEGER; VIRTUAL; {   㪢 }
                        FUNCTION SymbolFullHeight:INTEGER; VIRTUAL;
                                                                {    ⮬  뭮 }
                        FUNCTION SymbolWidth (C:CHAR):INTEGER;VIRTUAL;
                                                                { ਭ ᨬ   ᥫ}
                        FUNCTION StringLength(Gap:INTEGER;
                                S:STRING):INTEGER;VIRTUAL;        {  ப  ᥫ }
                        PROCEDURE Transform(x1,y1,x,y:INTEGER;
                                VAR XX,YY :INTEGER);VIRTUAL;        { ८ࠧ न }
                        PROCEDURE OutString(xx0,yy0,Gap:INTEGER;
                                Fill:BOOLEAN;S:STRING);VIRTUAL; { 뢮 ப }
                END;

        IMPLEMENTATION

                PROCEDURE Font1.SetParameters1(MXX,MYY,A:FLOAT;
                        X00,Y00:INTEGER);                        { 樠 ࠬ஢ ८ࠧ }

                BEGIN
                        MX := MXX;
                        MY := MYY;

                        SN:=SIN(PI*A/180.0);
                        CN:=COS(PI*A/180.0);
                        X0:=X00;
                        Y0:=Y00;
                END;

                FUNCTION Font1.SymbolHeight:INTEGER;                {   㪢 }
                BEGIN
                        SymbolHeight := ROUND(BgiFont.SymbolHeight * MY);
                END;

                FUNCTION Font1.SymbolFullHeight:INTEGER;        {    ⮬  뭮 }
                BEGIN
                        SymbolFullHeight := ROUND(BgiFont.SymbolHeight * MY);
                END;

                FUNCTION Font1.SymbolWidth (C:CHAR):INTEGER;        { ਭ ᨬ   ᥫ}
                BEGIN
                        SymbolWidth := ROUND((BgiFont.SymbolWidth(C)) * MX);
                END;

                FUNCTION Font1.StringLength(Gap:INTEGER;
                        S:STRING):INTEGER;                        {  ப  ᥫ }
                BEGIN
                        StringLength:= BGIFont.StringLength(ROUND(GAP * MX),S);
                END;

                PROCEDURE Font1.Transform(x1,y1,x,y:INTEGER;
                        VAR XX,YY :INTEGER);                        { ८ࠧ न }
                VAR

                        X2,Y2:        FLOAT;

                BEGIN

                        X2 := x1 + x * MX - x0;
                        Y2 := y1 - y * MY - y0;
                        XX := ROUND(x0 + CN * X2 + SN * Y2);
                        YY := ROUND(y0 - SN * X2 + CN * Y2);
                END;

                PROCEDURE Font1.OutString(xx0,yy0,Gap:INTEGER;
                        Fill:BOOLEAN;S:STRING);                         { 뢮 ப }
                BEGIN
                        BgiFont.OutString(xx0,yy0, ROUND(Gap * MX), Fill, S);
                END;

END.


