{⨭ 5
 ।⢠  ࠡ  BGI 䮭⠬}

{***************************************************************}
{ List05.TXT -  ।⢠  ࠡ  BGI 䮭⠬        }
{ (BGI-Borland Graphics Interface)                              }
{ (C) 宭 ..,1992                                         }
{***************************************************************}

UNIT List05;

        INTERFACE

        USES GRAPH;

        CONST
                MaxSize = MaxInt * 2 + 1;                       { ᨬ ࠧ ᨢ }

        TYPE
                DefaultArray = ARRAY [0..MaxSize-1] of BYTE;    { ⨢ ᨢ  ᫥ ᮢ}
                PDefaultArray = ^DefaultArray;                  { ⥫  䨪⨢ ᨢ }

                {$I LIST0.TXT}                                 { ᠭ 䨪 䮭 }
                {$I LIST2.TXT}                                 { ᠭ  䮭 }
                {$I LIST3.TXT}                                 { ⥫ 䮭 }
                {$I LIST4.TXT}                                 {  䮭 }

        TYPE
                BGIFont = OBJECT
                        CONSTRUCTOR LoadBgiFont(FontName:STRING);
                        DESTRUCTOR Done; VIRTUAL;
                        FUNCTION SymbolHeight:INTEGER; VIRTUAL; {   㪢 }
                        FUNCTION SymbolFullHeight:INTEGER; VIRTUAL;
                                                                {   ⮬  뭮 }
                        FUNCTION SymbolWidth (C:CHAR):INTEGER;VIRTUAL;
                                                                { ਭ ᨬ   ᥫ}
                        FUNCTION StringLength(Gap:INTEGER;
                                S:STRING):INTEGER;VIRTUAL;      {  ப  ᥫ }
                        PROCEDURE Transform(x1,y1,x,y:INTEGER;
                                VAR XX,YY :INTEGER);        VIRTUAL;{ ८ࠧ न }
                        PROCEDURE OutSymbol(x1,y1:INTEGER;
                                Fill:Boolean;C:CHAR);        VIRTUAL;{ 뢮 ᨬ C}
                        PROCEDURE OutString(x0,y0,Gap:INTEGER;
                                Fill:BOOLEAN;S:STRING);        VIRTUAL;{ 뢮 ப }

                        PRIVATE
                                Loaded,                         {  㧪 䮭 }
                                GotMemory:        BOOLEAN;      {  १ࢨ஢   䮭 }
                                FontFile:        FILE;          { ,  ஬ ࠭ 䮭}
                                FileLen:        LONGINT;        {  䠩  䮭⮬}
                                FontPtr:        POINTER;        { ⥫  砫 ᠭ 䮭
                                                                 ⨢ }
                                PrefPtr:        PBgiFontPrefix; { ⥫ 䨪 䮭 }
                                DefaultPtr:        PDefaultArray;{ ⥫  䨪⨢ ᨢ, ᯮ㥬
                                                                 ᫥ ᮢ }
                                BgiHeaderPtr:        PBgiFontHeader;{ ⥫   䮭 }
                                BgiFontDscPtr:        PBGIFontDsc;{ ⥫  砫 ᠭ ᨬ }
                                Offs:                POffSetTable;{ ⥫  ⠡ ᬥ饭 ᠭ
                                                                  ᨬ }
                                Widths:                PWidthTable;{ ⥫  ⠡ ਭ ᨬ }
                                Vect:                PVector;      { ⥫  ᠭ ࢮ ᨬ }

                                PROCEDURE SetFontPtrs;             { ஢ 㪠⥫   䮭 }
                                FUNCTION CheckFont:BOOLEAN;        { ஢ઠ ४⭮ 䮭 }
                END;
               PBGIFont = ^BGiFont;

        IMPLEMENTATION

                CONSTRUCTOR BGIFont.LoadBgiFont(FontName:STRING);  {  }

                VAR
                        p:                POINTER;
                        MaxMem:                LONGINT;
                        NumRead:        WORD;

                BEGIN
                        FontPtr := NIL;
                        {$I-}
                        ASSIGN(FontFile,FontName);
                        RESET(FontFile,1);
                        GotMemory := FALSE;
                        IF (IoResult = 0) THEN
                        BEGIN                                      {  c  FontName   }
                                FileLen := FILESIZE(FontFile);
                                MaxMem:=MAXAVAIL;                  { 쪮  㯭? }
                                IF FileLen < MaxMem THEN BEGIN
                                        GetMem(FontPtr,FileLen);
                                        GotMemory:=TRUE;
                                        BLOCKREAD(FontFile,FontPtr^,FileLen,NumRead);
                                        IF NumRead = FileLen THEN BEGIN
                                                SetFontPtrs;       { ⠭ 㪠⥫ }
                                                Loaded:= CheckFont;{ ஢ઠ ४⭮ 㦥 䮭 }
                                        END
                                        ELSE BEGIN
                                                Loaded := FALSE;
                                                Done;
                                        END;
                                END
                                ELSE        Loaded:=FALSE;
                        END
                        ELSE Loaded:=FALSE;
                        {$I+}
                END;

                DESTRUCTOR BGIFont.Done;                           {  }
                BEGIN
                        IF GotMemory THEN FREEMEM(FontPtr,FileLen);
                        GotMemory := FALSE;
                        Loaded := FALSE;
                END;

                PROCEDURE BGIFont.SetFontPtrs;                     { ஢ 㪠⥫   䮭 }
                VAR
                        I, J, K, L:        WORD;

                BEGIN
                        PrefPtr := FontPtr;
                        DefaultPTR := FontPtr;

                        {
                         砫  䮭  䨪஢, 
                          ⢫  ᨬ $1A
                        }
                        I:=0;
                        WHILE((DefaultPtr^[I]<>$1A) and (I<=300)) DO BEGIN
                                Inc(I);
                        END;

                        BgiHeaderPtr := @DefaultPtr^[I];          { ⥫   䮭 }
                        BgiFontDscPtr :=
                                @DefaultPtr^[BgiHeaderPtr^.HeaderSize];{ ⥫  ᠭ 䮭 }
                        Offs := @DefaultPtr^[BgiHeaderPtr^.HeaderSize +
                                SIZEOF(BgiFontDscPtr^)];           { ⥫  ⠡ ᬥ饭 ᠭ
                                                                       ᨬ }
                        Widths :=@DefaultPtr^[BgiHeaderPtr^.HeaderSize +
                                SIZEOF(BgiFontDscPtr^) +
                                2*BgiFontDscPtr^.SymbolsInFont];   { ⥫  ⠡ ᫠ ஢,
                                                                     ᯮ㥬  ᠭ  ᨬ }
                        Vect := @DefaultPtr^[BgiHeaderPtr^.HeaderSize +
                                BgiFontDscPtr^.StrokesOffset];     { ⥫  ᠭ ୮
                                                                     ।⠢ ࢮ ᨬ }
                END;

                FUNCTION BGIFont.SymbolHeight:INTEGER;              {   㪢 }
                BEGIN
                        SymbolHeight:= BGIFontDscPtr^.CapitalHeight - BGIFontDscPtr^.BaseLine;
                END;

                FUNCTION BGIFont.SymbolFullHeight:INTEGER;          {    ⮬  뭮 }
                BEGIN
                        SymbolFullHeight:= BGIFontDscPtr^.CapitalHeight - BGIFontDscPtr^.DesCender;
                END;

                FUNCTION BGIFont.SymbolWidth (C:CHAR):INTEGER;      { ਭ ᨬ   ᥫ}
                BEGIN
                        SymbolWidth:= Widths^[ORD(C) - BGIFontDscPtr^.FirstSymbol];
                END;

                FUNCTION BGIFont.CheckFont:BOOLEAN;                 { ஢ઠ ४⭮ 䮭 }
                BEGIN
                        CheckFont :=
                                (PrefPtr^.FontSignature[1] = 'P')        AND
                                (PrefPtr^.FontSignature[2] = 'K')        AND
                                (PrefPtr^.FontSignature[3] = #8 )        AND
                                (PrefPtr^.FontSignature[4] = #8        )        AND
                                (BgiHeaderPtr^.Signature = $1A)                AND
                                (BgiFontDscPtr^.Signature = '+');
                END;

                PROCEDURE BGIFont.Transform(x1,y1,x,y:INTEGER;
                        VAR XX,YY :INTEGER);                        { ८ࠧ न }
                BEGIN
                        XX := x1 + x;
                        YY := y1 - y;                               {   ᢥ }
                END;
FUNCTION BGIFont.StringLength(Gap:INTEGER;
                                S:STRING):INTEGER;                  {  ப  ᥫ }
                VAR
                        I,L:        WORD;
                BEGIN
                        L:=0;
                        FOR I := 1 TO LENGTH(S) DO L := L + SymbolWidth(S[i]) + Gap;
                        StringLength:=L;
                END;

                PROCEDURE BGIFont.OutSymbol(x1,y1:INTEGER;
                        Fill:Boolean;C:CHAR);                       { 뢮 ᨬ }
                VAR
                        cc:                char;
                        I, J, K, JF:        WORD;
                        xx,yy,ux,
                        uy,mx,my:        INTEGER;
                        PolyLine : ARRAY[1..255]
                                        OF POINTTYPE;               {  ᨬ    }

                BEGIN
                        I:= ORD(c) - BGIFontDscPtr^.FirstSymbol;
                        IF I<= BGIFontDscPtr^.SymbolsInFont THEN K := I        { ஢ઠ  ᨬ }
                        ELSE K := 0;

                        J := Offs^[K] div 2;                        { 饭 ᠭ ᨬ   ᫮ }
                        Self.Transform(x1,y1,0,0,mx,my);
                        MOVETO(mx,my);                                        { 砫쭮 樮஢ ᨬ }
                        JF:= 1;                                                { 砫쭮 ᫮ 祪   }
                        PolyLine[JF].x:=mx;
                        PolyLine[JF].y:=my;

                        REPEAT WITH Vect^[J] DO BEGIN

                                xx:= x AND $7F;                                { ਧ⠫쭠 न ⥪饣 }
                                {$R-}
                                IF (y AND $40)<>0 THEN     { ⨪쭠 न ⥪饣 }
                                        yy:= y or $FF80    { ८ࠧ ⥫쭮 SHORTINT  INTEGER}
                                ELSE yy:= y and $7F;       { ८ࠧ ⥫쭮 SHORTINT  INTEGER}
                                {
                                        ८ࠧ न
                                }

                                Transform(x1,y1,xx,yy,mx,my);

                                IF (Fill AND (BgiFontDscPtr^.FillFlag<>0)) THEN
                                                                    {  ᨬ }
                                BEGIN
                                        IF (((y AND $80) = 0) OR ((Vect^[j].x AND $80) = 0)) THEN
                                        BEGIN                                 { ᪠ }
                                                IF JF>2 THEN FILLPOLY(JF,PolyLine);
                                                                    { ᪠ ⮫쪮 ⮣,   
                                                                          祪 }
                                                JF :=0;
                                                IF (y AND $80) = 0 THEN BEGIN
                                                                    {   }
                                                        JF := 1;
                                                        PolyLine[JF].x:=mx;
                                                        PolyLine[JF].y:=my;
                                                        MOVETO(mx,my);
                                                END;
                                        END
                                        ELSE BEGIN                  {     ᨬ }
                                                INC(JF);
                                                PolyLine[JF].x:=mx;
                                                PolyLine[JF].y:=my;
                                                LINETO(mx,my);
                                        END
                                END
                                ELSE BEGIN                          { 뢮 ᨬ }
                                        IF (y AND $80) = 0 THEN
                                                MOVETO(mx,my)       {   窥 mx,my }
                                        ELSE
                                                LINETO(mx,my);                { 뢮  }
                                END;

                                INC(J);                                        { 室  ᫥饬 }
                        END;
                        UNTIL ((Vect^[j].x and $80) = 0);
                END;

                PROCEDURE BGIFont.OutString(x0,y0,Gap:INTEGER;
                        Fill:BOOLEAN;S:STRING);                                { 뢮 ப }
                VAR
                I,L,X1,Y1:        INTEGER;

                BEGIN
                        X1:=X0;
                        Y1:=Y0;
                        FOR I:=1 TO LENGTH(S) DO BEGIN
                                OutSymbol(x1,y1,Fill,S[I]);
                                x1 :=x1 + SymbolWidth(S[I]) + Gap;
                        END;
                END;

END.


